﻿var sites ={};
sites.items = {
  "weibo.com": {
    name: "weibo.com",
    items:[
      {reg: /sinaimg.cn\/.*\//, value: "sinaimg.cn/large/"}
    ]
  },
  "lofter.com": {
    name: "lofter.com",
    items:[
      {reg: /\?.*/, value: ""},
    ]
  },  
  "tumblr.com": {
    name: "tumblr.com",
    items:[
      {reg: /_\d{3,}./, value: "_1280."}
    ]
  },
  "boomboomthelabel.com": {
    name: "boomboomthelabel.com",
    items:[
      {reg: /\?v=\d*/, value: ""},
      {reg: /_1024x1024/, value: ""},
      {reg: /_grande/, value: ""}
    ]  
  },
  "shopify.com": {
    name: "shopify.com",
    items:[
      {reg: /\?v=\d*/, value: ""},
      {reg: /_1024x1024/, value: ""},
      {reg: /_grande/, value: ""}
    ]  
  },
  "shopflynation.com": {
    name: "shopflynation.com",
    items:[
      {reg: /\?v=\d*/, value: ""},
      {reg: /_1024x1024/, value: ""},
      {reg: /_grande/, value: ""}
    ]  
  },
}


chrome.browserAction.onClicked.addListener(function(tab) {
  chrome.tabs.executeScript({
      code: ''
  });
});

chrome.contextMenus.create({
  title: "收藏原始图片",
  contexts: ["image"],
  documentUrlPatterns: [
    "http://*/*", "https://*/*"
  ],
  onclick: function(info){
    var page = new URL(info.pageUrl);
    var url = info.srcUrl;
    var mc = page.hostname.toLowerCase().match(/([a-z0-9-]*)[.]{1}([a-z]{3})$/);
    var domain = "";
    if(!mc){ 
      mc = page.hostname.toLowerCase().match(/([a-z0-9-]*)[.]{1}([a-z0-9-]*)[.]{1}([a-z]{2})$/);
    }
    if(mc){
      domain = mc[0]; 
    }
    var site = sites.items[domain];
    if(site){
      for(var i=0; i<site.items.length; i++){
        var r = site.items[i];
        url = url.replace(r.reg, r.value);
      }
    }
    var hostname = window.localStorage.getItem("ext.hostname") || "https://www.bimwook.com";
    chrome.tabs.create({
      url:  hostname + '/woo/bin/cruiser/add.do?callback=/woo/var/cruiser.htm&url=' + window.encodeURIComponent(url),
      //url: url,
      selected : false
    });  
  }
});
